<!DOCTYPE html>
<html>
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1, minimum-scale=1, maximum-scale=1, user-scalable=no">
		<title>LRC</title>
		<script src="https://code.jquery.com/jquery-3.4.1.min.js"></script>
		<style>
			div{
				width:340px;
				height:500px;
				margin:0 auto;
				overflow:hidden;
			}
			ul{
				transition-duration: 600ms;
			}
			ul, li{
				list-style:none;
				padding: 0;
				margin: 0;
			}
			li.on{
				color: red;
			}
			p{
				overflow: hidden;
				text-overflow: ellipsis;
				height: 16px;
				line-height: 16px;
				-webkit-line-clamp: 1;
				-webkit-box-orient: vertical;
				display: -webkit-box;
				text-align: center;
				margin-top: 0;
				margin-bottom: 16px;
			}
			audio{
				margin-top: 10px;
			}
		</style>
	</head>
	<body>
		<div>
			<ul id="lrclist" style="transform: translateY(250px);"><!-- 保证歌词在正中间 -->
				
			</ul>
		</div>
		<audio id="audio" src="./SIP-10193_50243456_20191204201732.wav" controls="controls" autoplay="true"></audio>
		
		<script>
		var lrcJSON = {
            "[al:unknown]":"",
            "[ar:unknown]":"",
           " [au:unknown]":"",
            "[by:WangJH]":"",
            "[re:ASR tools]":"",
            "[ti:unknown]":"",
            "[ve:1.0]":"",

            "[00:00.00]录音名称":" unknow",
            "[00:00.01]" :"",

            "[00:00.03] n0 (  0)": "电话啊，喂吴哥。",
            "[00:03.31] n0 (  3)": " 发话时长 3.28 秒",
            "[00:03.32]" :"",
           " [00:05.67] n1 (  5)": "哎哥。",
           " [00:06.60] n1 (  6)": "发话时长 0.93 秒",
            "[00:06.61]" :"",
            "[00:06.84] n0 (  6)": "哎你好你好诶我是阳光电话车险中心上网哎吴哥。",
            "[00:10.32] n0 ( 10)": "发话时长 3.48 秒",
           " [00:10.33]" :"",
		};
		
		
		var lrcTime = [];//歌词对应的时间数组
		var ul = $("#lrclist")[0];//获取ul
		
		var i = 0;
		$.each(lrcJSON, function(key, value) {//遍历lrc
			lrcTime[i++] = parseFloat(key.substr(1,3)) * 60 + parseFloat(key.substring(4,10));//00:00.000转化为00.000格式
			ul.innerHTML += "<li><p>"+lrcJSON[key]+"</p></li>";//ul里填充歌词
		});
		lrcTime[lrcTime.length] = lrcTime[lrcTime.length-1] + 3;//如不另加一个结束时间，到最后歌词滚动不到最后一句
		
		
		var $li = $("#lrclist>li");//获取所有li
		
		var currentLine = 0;//当前播放到哪一句了
		var currentTime;//当前播放的时间
		var audio = document.getElementById("audio");
		var ppxx;//保存ul的translateY值
		
		audio.ontimeupdate = function() {//audio时间改变事件
			currentTime = audio.currentTime;
			for (j=currentLine, len=lrcTime.length; j<len; j++){
				if (currentTime<lrcTime[j+1] && currentTime>lrcTime[j]){
					currentLine =  j;
					ppxx = 250-(currentLine*32);
					ul.style.transform = "translateY("+ppxx+"px)";
					$li.get(currentLine-1).className="";
					console.log("on"+currentLine);
					$li.get(currentLine).className="on";
					break;
				}
			}
		};
		
		audio.onseeked = function() {//audio进度更改后事件
			currentTime = audio.currentTime;
			console.log("  off"+currentLine);
			$li.get(currentLine).className="";
			for (k=0, len=lrcTime.length; k<len; k++){
				if (currentTime<lrcTime[k+1] && currentTime<lrcTime[k]){
					currentLine =  k;
					break;
				}
			}
		};
		
		</script>
	</body>
</html>
